#!/bin/bash
#
# this script will add/remove/list group trials from site command.
#
# Edit the following path to your group trial db path.
#
GRPDB=/ftp-data/jtc/groups.db
COMMAND=$1
GRP=$2
MINMB=$3
CHKTYPE=$4

if [ "$COMMAND" = "" ]; then
	echo "Usage: site grptrial add <group> <minmb> <checktype>"
	echo "  or : site grptrial remove <group>"
	echo "  or : site grptrial list"
	echo "      <group> must be existing group"
	echo "      <minmb> a number in MB which the group must complete"
	echo "      <checktype> can be MONTHUP or WKUP or DAYUP"
	exit
fi

if [ "$COMMAND" = "list" ]; then
	cat $GRPDB | awk '{print "Group "$1" must upload "$2"mB per "$3}'
	exit
fi

if [ "`grep ^$GRP: /etc/group`" = "" ]; then
	echo "ERROR: The group \"$GRP\" does not exist !"
	exit
fi

if [ "$COMMAND" = "remove" ]; then
	if [ "`grep ^$GRP $GRPDB`" = "" ]; then
		echo "ERROR: The group \"$GRP\" was not found!"
		exit
	fi
        cat $GRPDB | grep -v ^$GRP > $GRPDB
        echo "The group \"$GRP\" was removed"
        exit
fi

if [ "`grep ^$GRP $GRPDB`" != "" ]; then
	echo "ERROR: The group \"$GRP\" already added, please remove it first."
	exit
fi

if ! echo $MINMB | grep -E '^[0-9]+$' > /dev/null; then
	echo "ERROR: \"$MINMB\" is not an integer !"
	exit
fi

if [ "$CHKTYPE" != "MONTHUP" ] && [ "$CHKTYPE" != "WKUP" ] && [ "$CHKTYPE" != "DAYUP" ]; then
	echo "ERROR: checktype must be MONTHUP WKUP or DAYUP !"
	exit
fi

if [ "$COMMAND" = "add" ]; then
	echo "$GRP $MINMB $CHKTYPE" >> $GRPDB
	echo "The group \"$GRP\" was added as trial group, they muse read $MINMBMb per $CHKTYPE"
	exit
fi

echo "Usage: site grptrial <add/remove/list>"
