set jtc "/glftpd/bin/jtc"
set trialtag "\[TRiAL-C\]"
set siteprefix "!ftp"

bind pub -|- [set siteprefix]passed trialchk
bind pub -|- [set siteprefix]filter filterchk
bind pub -|- [set siteprefix]groupassed groupchk
bind pub -|- [set siteprefix]groupstats groupstatchk

proc groupchk {nick host handle chan text} {
	global trialtag jtc siteprefix

	if {$text == ""} {
		puthelp "PRIVMSG $chan :$trialtag Usage: [set siteprefix]groupassed group."
		return 0
	}
	putquick "PRIVMSG $chan :[exec $jtc -n -gs $text]"
}

proc groupstatchk {nick host handle chan text} {
        global trialtag jtc siteprefix

        if {$text == ""} {
                puthelp "PRIVMSG $chan :$trialtag Usage: [set siteprefix]groupstats group."
                return 0
        }
        set userlst [split [exec $jtc -n -g $text] "\n"] 
        foreach userline $userlst {
                putquick "PRIVMSG $chan :$userline"
        }
}


proc trialchk {nick host handle chan text} {
	global trialtag jtc siteprefix

	if {$text == ""} {
		puthelp "PRIVMSG $chan :$trialtag Usage: [set siteprefix]passed user."
		return 0
	}
	putquick "PRIVMSG $chan :[exec $jtc -n -us $text]"
}


proc filterchk {nick host handle chan text} {
	global trialtag jtc siteprefix

	if {[llength $text]!=2} {
		putquick "PRIVMSG $chan :$trialtag Usage:[set siteprefix]filter <normal|trial|exempt|all> <passed|failed|period>"
		return 0
	}
	set class [lindex $text 0]
	set status [lindex $text 1]
	if {[regexp "normal|trial|exempt|all" $class]==0 || [regexp "passed|failed|period|all" $status]==0} {
		putquick "PRIVMSG $chan :$trialtag Usage: \002[set siteprefix]filter\002 <normal|trial|exempt|all> <passed|failed|period|all>"
		return 0
	}
	if {[string match $class "all"] && [string match $status "all"]} {
		set result [exec $jtc -n -sl]
	} elseif {[string match $class "all"]} {
		set result [exec $jtc -n -sl -status $status]
	} elseif {[string match $status "all"]} {
		set result [exec $jtc -n -sl -class $class]
	} else {
		set result [exec $jtc -n -sl -class $class -status $status]
	}
	
	set num [llength $result]
	putquick "PRIVMSG $chan :$trialtag There are \002$num\002 users whose class is \002$class\002 and status is \002$status\002:"
	putquick "PRIVMSG $chan :$trialtag $result"

}

putlog "-> Successfully Loaded JeTrial-C's Passedbot script for jtc-0.20 (By \[Jedi\])"
