/******************************************************************************
* Filename: strlib.c
* Description: a group of functions to handle strings
* Author: [Jedi] (jedi_il@hotmail.com)
* Copyright 2002 [Jedi] 
* See COPYING for the GPL GNU
*
*    This file is part of JeTrial-C.
*
*    JeTrial-C is free software; you can redistribute it and/or modify      
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    JeTrial-C is distributed in the hope that it will be useful,         
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with Foobar; if not, write to the Free Software 
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*
******************************************************************************/

#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "../header/strlib.h"


/******
 This function is the same as strsplit()
 but it gets the output string and retuns the pointer to it.
*************************************************************/
char *strsplit_s(char *output, const char *str, const char separator, int index) {
        int idx=0,t=0,start=0,end=0,foundsep=0;

	if (index<0) {
		strcpy(output,str);
		return output;
	}
	if (str==NULL) {
		*output='\0';
		return output;
	}
	for (t=0 ; *(str+t) != '\0' ; t++) {
		if (*(str+t)==separator) { /* found index */
			foundsep=1;
			if ((idx+1)==index) { start=t+1; }
			else if (idx==index) { end=t-1; break; }
			idx++;
		}
	}

	if ((foundsep==0) || (index>idx)) { 
		*output='\0';
		return output;
	}
	if ((start>0) && (end==0)) end=t;
	strncpy(output,str+start,end-start+1);
	*(output+end-start+1)='\0';
	return output;
}


char *strsplit(const char *str, const char separator, int index) {
        int idx=0,t=0,start=0,end=0,foundsep=0;
	
//	if (strchr(str,separator)==NULL) return NULL;
	if (index<0) return substring(str,0,strlen(str));
	if (str==NULL) return NULL;

        while (*(str+t)!='\0')  {
                if (*(str+t)==separator) { // found index
			foundsep=1;
                        if ((idx+1)==index) { start=t+1; }
                        else if (idx==index) { end=t-1; break; }
                        idx++;
                }
                t++;
        }
        if ((foundsep==0) || (index>idx)) return NULL;
        if ((start>0) && (end==0)) end=t;
	return substring(str,start,(end-start+1));
}


void chomp(char *str) {
        int k;
        k=strlen(str)-1;
        if (*(str+k)=='\n') { *(str+k)='\0'; }
}

char *substring(const char *str, int start, int length) {
        char *newstr;
        int t=0;
        newstr=(char *)malloc(sizeof(char)*(length+1));         // room for length + null 
		if (newstr==NULL) return NULL;	// malloc failed, return null
        for (t=0;t<length;t++) {
                *(newstr+t)=*(str+start+t);
        }
        *(newstr+t)='\0';
        return newstr;
}

char *strtolower(const char *str) {
	char *newstr;
	int t=0;
	newstr=(char *)malloc(sizeof(char)*(strlen(str)+1));
	if (newstr==NULL) return NULL;	// malloc failed, return null
	for(t=0;t<=strlen(str);t++) {
		*(newstr+t)=tolower((int)*(str+t));
	}
	//*(newstr+t+1)='\0';
	return newstr;
}
		
